﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet 
# Projet Le mini site 
# Fichier : Page.as
*/
package {
	import flash.display.*;
	import flash.events.*;
	public class Page extends Sprite {
		// a. Définition des propriétés d'une Page
		private var forme:Forme;
		// Les minis rubriques sont créées avec les pages, elles sont accessibles par toutes les classes de l'application
		public static  var lesMinisRubriques:LesMinis;
		private var titre:TitreTexte;

		// b. Définition du constructeur Page()
		public function Page(nnum:uint, nx:Number, ny:Number, nlar:Number, nhau:Number, ncou:uint,  nelt:uint, ttxt:TitreTexte) {
			titre = ttxt;
			// Créer une forme rectangulaire colorée
			forme = new Forme(nnum, nlar, nhau,  ncou, titre.contenu, nelt, false);
			// Positionner la forme
			forme.x = nx;
			forme.y = ny;
			forme.alpha = 0;
			addChild(forme);
			// Créer les mini rubriques, si elles n'ont pas encore été créées
			if (lesMinisRubriques == null) {
				lesMinisRubriques = new LesMinis();
				addChild(lesMinisRubriques);
			}
		}
        // Description de l'agrandissement sur l'axe des X
		function agrandirPageEnX():void {
			var ecartX:Number;
			var positionCouranteX:Number;
			var deplacementX:Number;
			positionCouranteX = forme. x;
			ecartX = MiniSite.finalXPage - positionCouranteX;
			deplacementX= ecartX / 6;
			forme.x= positionCouranteX + deplacementX;
			forme.width+=MiniSite.largeurScene/25;
			forme.alpha+=0.05;
			if (Math.abs(deplacementX)  < 0.4) {
				forme.removeEventListener(Event.ENTER_FRAME, agrandirPageEnX);
				forme.addEventListener(Event.ENTER_FRAME, agrandirPageEnY);
				dispatchEvent(new Event(Event.COMPLETE));
				forme.alpha = 1;
				forme.width=MiniSite.largeurPage;
			}
		}

        // Description de l'agrandissement sur l'axe des X
		function agrandirPageEnY(e:Event):void {
			var cible:Forme = e.currentTarget  as Forme;
			var ecartY:Number;
			var positionCouranteY:Number;
			var deplacementY:Number;
			cible.height+=MiniSite.hauteurScene/24;
			positionCouranteY = cible. y;
			ecartY = MiniSite.finalYPage - positionCouranteY;
			deplacementY= ecartY / 6;
			cible.y= positionCouranteY + deplacementY;

			if (Math.abs(deplacementY)  < 0.4) {
				cible.removeEventListener(Event.ENTER_FRAME, agrandirPageEnY);
				cible.height = MiniSite.hauteurPage;
				cible.x =MiniSite.finalXPage;
				cible.y =MiniSite.finalYPage;
				cible.alpha = 1;
				titre.dessinerVertical(MiniSite.largeurPage - 100, MiniSite.finalYPage+10);
				// Afficher les mini rubriques, en spécifiant quelle page vient de s'afficher
				lesMinisRubriques.afficherLesMinis(cible.numero);
				addChild(titre);

			}
		}

	}// Fin de la classe Page
}