﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet 
# Projet Le mini site 
# Fichier : Rubrique.as
*/
package {
	import flash.display.*;
	import flash.events.*;
	public class Rubrique extends Sprite {
		// a. Définition des propriétés d'une Rubrique
		private var titre:TitreTexte;
		private var forme:Forme;


		// b. Définition du constructeur Rubrique()
		public function Rubrique(nnum:uint, nx:Number, ny:Number,  ncou:uint, nelt:uint, ttxt:TitreTexte) {
			titre = ttxt;
			// Créer une forme erctangulaire colorée
			forme = new Forme(nnum, MiniSite.largeurRubrique, MiniSite.hauteurRubrique,  ncou, titre.contenu, nelt, true);
			// Positionner la forme
			forme.x = nx;
			forme.y = ny;
			// Rendre la forme invisible
			forme.alpha = 0;
			// Afficher le titre de la rubrique à la vertical
			titre.dessinerVertical(MiniSite.largeurRubrique - 50, 20);
			addChild(forme);
			forme.addChild(titre);
			// Ecouter Event.ENTER_FRAME pour que voir la rubrique se déplacer 
			forme.addEventListener(Event.ENTER_FRAME, seDeplacerVers);
		}
		// Description du déplacement de la rubrique
		function seDeplacerVers(e:Event):void {
			var cible:Forme = e.currentTarget  as Forme;
			var positionCouranteX, positionCouranteY;
			var ecartX, ecartY;
			var deplacementX, deplacementY;
			positionCouranteX = cible.x;
			positionCouranteY = cible.y;
			ecartX =  cible.numero*MiniSite.largeurRubrique - positionCouranteX;
			deplacementX= ecartX / 6;
			cible.x= positionCouranteX + deplacementX;
			ecartY = MiniSite.finalYPage - positionCouranteY;
			deplacementY= ecartY / 6;
			cible.y= positionCouranteY + deplacementY;
			cible.alpha+=0.02;
			if (Math.abs(deplacementY ) < 0.4 &&  Math.abs(deplacementX) < 0.4) {
				cible.addEventListener(MouseEvent.MOUSE_UP, clicSurRubrique);
				cible.alpha=1;
				cible.x = cible.numero*MiniSite.largeurRubrique ;
				cible.y =MiniSite.finalYPage;
				cible.removeEventListener(Event.ENTER_FRAME, seDeplacerVers);
			}
		}
		// Rendre invisible les rubriques
		private function rendreInvisibleLesRubriques():void {
			for (var i:Number= 0; i < parent.numChildren; i++) {
				if ( parent.getChildAt(i) is Rubrique ) {
					parent.getChildAt(i).visible= false;
				}
			}
		}
		// Lorsqu'on clique sur une rubrique, une page est créée à l'aide du constructeur de la classe Page
		function clicSurRubrique(e:MouseEvent):void {
			rendreInvisibleLesRubriques();
			var tmpTitre:TitreTexte= new TitreTexte(90,forme.couleur,75, "Arista", titre.contenu);
			var tmpPage:Page = new  Page(forme.numero, MiniSite.largeurScene/2, MiniSite.hauteurScene/2,MiniSite.largeurPage/100, MiniSite.hauteurPage/100, forme.couleur, forme.nombreElt,tmpTitre );
			parent.addChild(tmpPage);
			// On écoute l'evt Event.ENTER_FRAME, pour afficher une page
			tmpPage.addEventListener(Event.ENTER_FRAME, afficherPage);
			// On écoute l'evt Event.COMPLETE, pour supprimer l'écouteur précédent
			tmpPage.addEventListener(Event.COMPLETE,sArreter);
		}

		private function afficherPage(e:Event):void {
			var cible:Page = e.currentTarget  as Page;
			cible.agrandirPageEnX();
		}
		private function sArreter(e:Event):void {
			var cible:Page = e.currentTarget  as  Page;
			cible.removeEventListener(Event.ENTER_FRAME, afficherPage);
		}
	}// Fin de la classe Rubrique
}